/*
 * create two gthreads and test thread-local storage
 */
#include <glib.h>
#include <signal.h>
#include "helper.c"

/* a signal handler for alarm */
static void
sig_alrm (int signo)
{
  GThread *me;

  g_print ("sig_alrm: Caught alrm\n");
  me = g_thread_self ();
  g_print ("sig_alrm: Caught from thread: %p\n", me);
  /* set us up a new one */
  alarm (1);
}

/* a thread we're going to create */
gpointer
a_thread (gpointer user_data)
{
  GThread *me;

  alarm (1);
  me = g_thread_self ();
  g_print ("a_thread: I am a thread and I am alive.\n");
  g_print ("a_thread: my gthread: %p\n", me);
  g_print ("a_thread: going endless.\n");
  endless_print ("T");
}

int
main (int argc, char *argv[])
{
  GThread *thread, *me;

  g_thread_init (NULL);

  me = g_thread_self ();
  g_print ("main:     my gthread: %p\n", me);

  g_print ("main:     creating thread\n");

  if (signal (SIGALRM, sig_alrm) == SIG_ERR)
    g_error ("Could not set up SIGALRM handler");

  thread = g_thread_create ((GThreadFunc) a_thread, NULL, TRUE, NULL);

  g_print ("main:     created thread: %p\n", thread);
  g_print ("main:     I am the main thread and I am alive.\n");
  g_print ("main:     going endless.\n");
  endless_print ("M");
}
